@echo off
REM    script to create patched version of the Firefox Setup exe

set fver="1.5.0.4"
set flang="en-GB"
set patchfile=1504.patch

REM add 7-Zip to the path
set path=%path%;c:\program files\7-Zip

echo Expand the setup file

7z x -ofirefox-%fver%-dev "Firefox Setup %fver%.exe"

echo Expand the XPI Files

cd firefox-%fver%-dev
7z x -obrowser.tmp browser.xpi
7z x -o%flang%.tmp %flang%.xpi

echo Expand the jar file

cd browser.tmp\bin\chrome
7z x -obrowser.tmp browser.jar

echo Apply the patch file
pause

cd ..\..\..
REM If you are patching by hand then 
REM  comment out the next line, and 
REM  patch the files while the script is paused here
patch -p 1 < ..\%patchfile%

echo Rebuild the setup file
pause

cd browser.tmp\bin\chrome\browser.tmp
7z u -r ..\browser.jar *

cd ..\..\..
7z u -r -x!*.tmp ..\browser.xpi *

cd ..\%flang%.tmp
7z u -r -x!*.tmp ..\%flang%.xpi *

cd ..
7z a -t7z -x!*.tmp ..\dev-%fver%.7z *.* -mx -m0=BCJ2 -m1=LZMA:d24 -m2=LZMA:d19 -m3=LZMA:d19 -mb0:1 -mb0s1:2 -mb0s2:3
cd ..
copy /b 7zSD.sfx + app.tag + dev-%fver%.7z Firefox-%fver%-custom.exe